﻿using System;

namespace TestProject
{
    /// <summary>
    /// 트리
    /// </summary>
    public class Tree
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 장소명
        /// </summary>
        private string locationName;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 위도 - Latitude

        /// <summary>
        /// 위도
        /// </summary>
        public double Latitude { get; set; }

        #endregion
        #region 경도 - Longitude

        /// <summary>
        /// 경도
        /// </summary>
        public double Longitude { get; set; }

        #endregion
        #region 장소명 - LocationName

        /// <summary>
        /// 장소명
        /// </summary>
        public string LocationName
        {
            get
            {
                return this.locationName;
            }
            set
            {
                if(value == null)
                {
                    throw new ArgumentNullException("LocationName");
                }

                if(value.Equals(this.locationName))
                {
                    return;
                }

                this.locationName = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - Tree()

        /// <summary>
        /// 생성자
        /// </summary>
        public Tree()
        {
            this.locationName = string.Empty;
        }

        #endregion
    }
}